Subject: bug#71179: [PATCH] In rgrep, check matching files before excluding files

From: Dmitry Gutov <[email-masked]>
Date: Sat, 25 May 2024 16:03:00 +0300

On 25/05/2024 15:51, Eli Zaretskii wrote:

>>>>> In my benchmarking, this takes (rgrep "foo" "*.el" "~/src/emacs/trunk/")
>>>>> from ~410ms to ~130ms.
>>>>
>>>> I can confirm improvement here (though not exactly 3x).
>>>>
>>>> 1.9s to 1.3s in a Linux checkout, for example. Nice.
>>>
>>> Which is still quite minor.
>>
>> A 30% improvement is nothing to sneeze at, especially for a code change
>> as simple as this one.
> 
> They are 30%, but they are only 600 milliseconds.

On my top-of-the-line laptop, even if it's a few years old. Take an 
older or slower machine - and you might as well see a multi-second 
difference. Just like in my example with the bigger project anyway.

One of my personal aims is to make Emacs more viable even for those who 
work on large projects. That's why I routinely test certain operations 
with Mozilla's codebase. And AFAIK Spencer's codebase is even larger.

>>>> Moving the files exclude instructions to the <F> placeholder is a slight
>>>> incompatibility
>>>
>>> Right, and for that reason, we cannot install this change as-is.  We
>>> need either a different command or a user option controlling the order
>>> (with a good explanation of the effect of the difference).
>>
>> A user option might work, but before we add one it would be great to
>> understand who are the users that it is for.
> 
> The ones for whom the proposed change will affect the results.
> 
>>> Sorry, such incompatible changes are not acceptable, definitely when
>>> the gain is so small.  Correctness trumps speed.
>>
>> Can you think of a specific problematic usage?
> 
> Why is that needed?  Isn't it clear that it can happen?

Provided we do add an option, knowing the actual audience could help 
name it better and document it better.

But so far the audience I can think of is the very rare people who 
misused the template's customization. And those can use an existing option.